;
;@@@@@@@@@@@@@@@@@@@@@@@@@
;@@@ lbg[NEvgREvO @@@
;@@@dsgdqQOOD`rlpTu[`@@@
;@@@@@@@@@@@@@@@@@@@@@@@@@
;@@@@@@ mhbQq @@@@@@@
;@@@@@@@@@@@@@@@@@@@@@@@@@
;|||||||||||||||||||||||||
;@@@@@@@@@@@@@'2002 Toyo-Linx,Co.,Ltd.
;

;//////////////////////////////////////////////////////
;						       
;//////////////////////////////////////////////////////
;
;----- ETHER_00.ASM -----------------------------------
;2002.01.17	IWi蕪


;******************************************************
;	pPbgM				       
;******************************************************
NIC_Receive:
	IN	A,(ISR)
	AND	00011100b
	JP	NZ,NICRcv_E1

	CALL	Receive_CHK
	JP	Z,NICRcv_E2
	XOR	A
	LD	(Remote_ADR),A
	LD	A,(BNRY_BUF)
	LD	(Remote_ADR+1),A
	LD	A,4
	LD	(Remote_LEN),A
	XOR	A
	LD	(Remote_LEN+1),A
	LD	HL,Receive_BUF
	CALL	Remote_Read

	LD	A,(RB_RSR)
	BIT	0,A
	LD	A,003h
	JP	Z,NICRcv_E4

	LD	HL,Remote_ADR
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	DE
	INC	DE
	INC	DE
	INC	DE
	LD	(HL),D
	DEC	HL
	LD	(HL),E

	LD	HL,Receive_BUF+2
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	DEC	DE
	DEC	DE
	DEC	DE
	DEC	DE
	LD	A,E
	LD	(Remote_LEN),A
	LD	A,D
	LD	(Remote_LEN+1),A
	CALL	Remote_Read

	LD	A,(RB_Type)
	CP	008h
	LD	A,004h
	JP	NZ,NICRcv_E3
	LD	A,(RB_Type+1)
	CP	IP_No
	JP	Z,NICRcv_IP
	CP	ARP_No
	JP	Z,NICRcv_ARP
	LD	A,005h
	JP	NICRcv_E3

NICRcv_IP:
	LD	A,(RB_IP_Ver)
	CP	045h
	LD	A,006h
	JP	NZ,NICRcv_E3
	LD	A,(RB_IP_PROT)
	CP	TCP_No
	JP	NZ,NICRcv_IP00
	LD	A,020h
	JP	NICRcv_OK

NICRcv_IP00:
	CP	UDP_No
	JP	NZ,NICRcv_IP02
	LD	A,021h
	JP	NICRcv_OK

NICRcv_IP02:
	CP	ICMP_No
	JP	NZ,NICRcv_IP04
	LD	A,022h
	JP	NICRcv_OK

NICRcv_IP04:
	LD	A,007h
	JP	NICRcv_E3

NICRcv_ARP:
	LD	A,010h
	JP	NICRcv_OK

NICRcv_OK:
	LD	(Protocol_No),A
	XOR	A
	LD	(Error_No),A
	CALL	Set_BNRY
	OR	A
	RET

NICRcv_E1:
	LD	A,001h
	LD	(Error_No),A
	CALL	NIC_Recovery
	SCF
	RET

NICRcv_E2:
	LD	A,002h
	LD	(Error_No),A
	SCF
	RET

NICRcv_E3:
	LD	(Error_No),A
	CALL	Set_BNRY
	SCF
	RET

NICRcv_E4:
	JP	NICRcv_E3


;******************************************************
;	pPbgM`FbN			       
;******************************************************
Receive_CHK:
	LD	A,01100010b
	OUT	(CR),A
	IN	A,(CURR)
	LD	(CURR_BUF),A

	LD	A,00100010b
	OUT	(CR),A
	IN	A,(BNRY)

	INC	A
	CP	Page_Stop
	JP	C,RcvCHK_00
	LD	A,Page_Start
RcvCHK_00:
	LD	(BNRY_BUF),A

	LD	D,A
	LD	A,(CURR_BUF)
	CP	D
	RET


;******************************************************
;	oE_WX^̃Zbg		       
;******************************************************
Set_BNRY:
	LD	A,(RB_NPP)
	CP	Page_Start
	JP	C,NIC_Recovery
	CP	Page_Stop
	JP	NC,NIC_Recovery

	DEC	A
	CP	Page_Start
	JP	NC,SetBNRY_00
	LD	A,Page_Stop-1
SetBNRY_00:
	LD	D,A
	LD	A,00100010b
	OUT	(CR),A
	LD	A,D
	OUT	(BNRY),A
	RET


;******************************************************
;	G[Jo[			       
;******************************************************
NIC_Recovery:
	LD	A,00100001b
	OUT	(CR),A

;	LD	A,2
;	CALL	Wait_ms

	XOR	A
	OUT	(RBCR0),A
	OUT	(RBCR1),A

	CALL	NIC_Initialize

	LD	A,00000100b
	OUT	(RCR),A
	XOR	A
	OUT	(TCR),A
	RET


